/*<![CDATA[*/

/**
 * Copyright (c) 2012-2013 V.Krishn (insteps.net)
 *
 * This file is part of Cookbook/App "Notebook" for PmWiki;
 * See accompanying package for license and more details.
 * Package: http://insteps.net/pr/a/pmwiki/Apps/Notebook
 *
 */

(function( Notebook, undefined ) {
  var config = Notebook.Config = function (config) {
    Notebook.config = config;
  }
  Notebook.version = '0.0.1'; //Config.version
  Notebook.copyright = 'Copyright (c) 2012-2013 V.Krishn (insteps.net)';
  Notebook.about = function () {
    alert(
      "\nVersion: "+this.version+
      "\n\nNotebook: \n \(Wiki based notes manager.\)\n\n"+
      this.copyright);
  }
}( this.Notebook = this.Notebook || {} ) );

(function( Notebook, undefined ) {
  var uploads = Notebook.Uploads = {
    event: function (e) {
      if(e.target.tagName !== 'A' || e.target.href == '' ) { return false; }
      uploads.href = e.target.href;
      return this;
    },
    settype: function (opt) {
      this.qnp = 'Site.PageLists';
      switch(opt) {
        case 'miniall': this.qn='/upload/listall'; break;
        case 'miniallorder': this.qn='/upload/listall'; break;
        case 'notmini': this.qn='/upload/listall'; break;
        case 'notimgs': this.qn='/upload/listall'; break;
        case 'default': this.qn='/upload/listall'; break;
      }
      return this;
    },
    setnode: function () {
      this.nodetitle = '/uploads+/'+this.fullname;
      return this;
    },
    seturl: function () {
      var p = new Poly9.URLParser(Qnotes.Url.decode('1', this.href));
      q = p.getQueryarray(); this.fullname = q.n;
      this.url = this.href+"&qn="+this.qn+"&qnp="+this.qnp;
      return this;
    },
    triggerType: function (opt) {
      switch(opt) {
        case 'qnoteitem':
          Qnotes.item.title = this.nodetitle;
          Qnotes.item.href = this.url;
          Qnotes.item.triggerEvent("mousedown");
        break;
      }
      return this;
    },
    trigger: function (e, opt, obj) {
      switch(opt) {
        case 'miniall':
          if(obj.href) { this.href = obj.href; } else { this.event(obj); }
          this.settype('miniall').seturl().setnode();
          this.triggerType('qnoteitem');
        break;
      }
      return this;
    }
  }
}( Notebook ) );

(function( Notebook, undefined ) {
  var wikipage = Notebook.WikiPage = {
    event: function (e) {
      return this;
    },
    prop: function () {
      return this;
    },
    propbox: function () {
      return this;
    }
  }
}( Notebook ) );

(function( Notebook, undefined ) {
  var browser = Notebook.Browser = {
    boxs: {},
    setWidth: function () {
      //setWidth, setHeight taken from 
      // Bubblehelp infoboxes, (C) 2007 Klaus Knopper <infobox@knopper.net>
      this.width = (window.innerWidth)? window.innerWidth+window.pageXOffset-16:
      (document.documentElement&&document.documentElement.clientWidth)?
      document.documentElement.clientWidth-20 : document.body.offsetWidth-20;
      return this;
    },
    setHeight: function () {
      this.height = (window.innerHeight)?window.innerHeight+window.pageYOffset  :
      (document.documentElement&&document.documentElement.clientHeight)?
      document.documentElement.clientHeight:document.body.offsetHeight;
      return this;
    },
    setBox: function (name) {
      Qnotes.body.create("div", { id : name }, true, "");
      this.box = Notebook.Browser.boxs[name] = $$(name);
      this.box.setStyle({ display: 'none', position: 'absolute', visibility: 'hidden' });
      this.box.onclick = function() { Notebook.Browser.boxs[name].style.display = 'none'; }
      return this.box;
    },
    getBox: function (name) {
       return Notebook.Browser.boxs[name];
    }
  }
}( Notebook ) );
 
var HomePage = function() {
  if (!e) var e = window.event;

  event2 = function (e) {
    if(e.target.tagName == 'A') {
      url = e.target.href+
      "&qn=/page/properties-1"+
      "&qnp=Site.PageLists"+
      "&async=1&qfmt=html&action=qnotes";

      if(typeof o1 !== 'undefined') { $(o1).style.outline = '0px' }
      o1 = o2 = $(e.target);
      $(o2).style.outline = '2px outset blue';
      o2.onclick = function() { return false; }
      _pos = Position.get(o2);

      Notebook.Browser.setWidth().setHeight();
      winW = Notebook.Browser.width;
      winH = Notebook.Browser.height;

      _w = 250; _t = _pos.top+_pos.height+2;
      _l = (_pos.left+_w > winW) ? _pos.left-60 : _pos.left+20;
      if( (_l+_w) > winW ) { _l = _l-_w-(winW-_pos.left); _w = ( winW-10 > _w) ? _w : winW-10; }
      if (_l < 0 ) {_l = 5; }
      
      box = new Notebook.Browser.setBox('wpgproperties');
      $(box).replaceContent("");
      
      if( o2.retrieve("props") ) {
        props = o2.retrieve("props");
        $(box).replaceContent(props);
      } else {
        Qnotes.Loading.show();
        DOMAssistant.AJAX.get(url, HandleProps);
      }
      
      box.setStyle({
        width: _w+'px', display: 'block',
          'z-index': '400', 'background-color': 'beige',
          left: _l+'px', top: _t+'px'
      });
      setTimeout(function() {
        _tpos = Position.get(box);
        _t = ( (_tpos.height+_t+20) > winH) ? _t-_tpos.height-_pos.height-5 : _t;
        box.setStyle({ top: _t+'px', visibility:'visible' });
      }, 100);
      //alert(_tpos.height+_t);alert(winH);
      //$(e.target).onmouseout = function() {
      //  hide = setTimeout(function() { box.setStyle({ 'display':'none' }); }, 8500);
      //}
      //tip('box');
      return false;
    }
    
    return this;
  }

  HandleProps = function (rdata) {
    if (DOMAssistant.AJAX.getStatus() ==  200 &&
        DOMAssistant.AJAX.getReadyState() == 4)
    {
      Qnotes.Loading.hide();
      $(box).replaceContent(rdata);
      r = $(box).elmsByAttribute("class", 'text', "div");
      $(box).replaceContent(r.first());
      o2.store("props", r.first());
      
      a = $('#'+ box.id + ' a');
      box.onmousedown = function(e) {
        if(e.target.tagName !== 'A' || a.length < 0) { return; }
        if('Open' === e.target.innerHTML) { e.target.href = o2.href; }
        if('View uploads' === e.target.innerHTML) {
          e.target.onclick = function() { return false; }
          Notebook.Uploads.trigger(e, 'miniall', o2); }
      }
    }
  }

  HandleMds = function (e) {
    if(qncategory.indexOf('-pages/') == -1 || $(e.target).hasClass('back')) { return; }
    if( Notebook.Uploads.showupload !== 1 ) { event2(e); }
  }
  Downloads = function () {
    Notebook.Uploads.showupload = 0;
    upld = $('#'+ qnotesBox.id + ' .downloads a');
    upld.each( function(elm, idx, set) { elm.target = '_blank'; });
    if(upld.length > 0) { Notebook.Uploads.showupload = 1; }
  }
  MiniboxInit = function () {
    minilinks = $(qnotesBox).elmsByAttribute('class', 'minilink', 'a');
    if(minilinks.length > 0) { LB={}; _.Ui(minilinks); }
  }

  $(qnotesBox).relayEvent("mousedown", "a", HandleMds);
  Qnotes.Init.qnoteext.push(MiniboxInit);
  Qnotes.Init.qnoteext.push(Downloads);

  // Back button  
  if ("onpopstate" in window) { window.onpopstate = HashChange; }
  $(qnotesBox).relayEvent("mousedown", "a.back:first", GoBack);
  Qnotes.Init.qnoteext.push(Back); AFLN();

  QnSetVPHt();
  window.onresize = function() { QnSetVPHt(); DOMAssistant.Qnotes.ResetPos(); Qnotes.item.triggerEvent("mousedown"); }

};

Qnotes.Ready.push(HomePage);
/*]]>*/
